---------------------
PatchSet 4873 
Date: 2002/09/05 10:28:18
Author: rbcollins
Branch: rfc2616
Tag: (none) 
Log:
reinstate client Via. Begin metadata separation in store interface

Members: 
	src/HttpReply.c:1.10->1.10.38.1 
	src/HttpReply.h:1.1->1.1.2.1 
	src/HttpRequest.c:1.7->1.7.58.1 
	src/HttpRequest.h:1.1->1.1.2.1 
	src/Makefile.am:1.23.6.2->1.23.6.3 
	src/acl.c:1.54.2.1->1.54.2.2 
	src/asn.c:1.17->1.17.10.1 
	src/cache_manager.c:1.7->1.7.80.1 
	src/client_side.c:1.70.2.2->1.70.2.3 
	src/errorpage.c:1.21->1.21.6.1 
	src/forward.c:1.16->1.16.6.1 
	src/ftp.c:1.26->1.26.2.1 
	src/gopher.c:1.17.2.1->1.17.2.2 
	src/http.c:1.21.6.2->1.21.6.3 
	src/icp_v2.c:1.6->1.6.2.1 
	src/icp_v3.c:1.5->1.5.2.1 
	src/internal.c:1.9->1.9.10.1 
	src/main.c:1.36->1.36.2.1 
	src/mime.c:1.11.38.1->1.11.38.2 
	src/neighbors.c:1.19->1.19.2.1 
	src/net_db.c:1.15->1.15.6.1 
	src/peer_select.c:1.15->1.15.6.1 
	src/protos.h:1.59->1.59.6.1 
	src/ssl.c:1.15->1.15.6.1 
	src/store.c:1.17->1.17.2.1 
	src/store_client.c:1.13->1.13.8.1 
	src/store_log.c:1.7->1.7.38.1 
	src/structs.h:1.64.2.2->1.64.2.3 
	src/typedefs.h:1.27->1.27.6.1 
	src/url.c:1.10->1.10.2.1 
	src/urn.c:1.16.2.1->1.16.2.2 
	src/wais.c:1.8->1.8.38.1 
	src/whois.c:1.9->1.9.2.1 

Index: squid/src/HttpReply.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/HttpReply.c,v
retrieving revision 1.10
retrieving revision 1.10.38.1
diff -u -r1.10 -r1.10.38.1
--- squid/src/HttpReply.c	24 Oct 2001 09:42:11 -0000	1.10
+++ squid/src/HttpReply.c	5 Sep 2002 10:28:18 -0000	1.10.38.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: HttpReply.c,v 1.10 2001/10/24 09:42:11 squidadm Exp $
+ * $Id: HttpReply.c,v 1.10.38.1 2002/09/05 10:28:18 rbcollins Exp $
  *
  * DEBUG: section 58    HTTP Reply (Response)
  * AUTHOR: Alex Rousskov
@@ -33,7 +33,9 @@
  *
  */
 
+#include "HttpReply.h"
 #include "squid.h"
+#include "HttpStrategy.h"
 
 
 /* local constants */
@@ -158,12 +160,19 @@
 }
 
 void
-httpReplyPackInto(const HttpReply * rep, Packer * p)
+httpReplyPackHeadersInto(const HttpReply * rep, Packer * p)
 {
     assert(rep);
     httpStatusLinePackInto(&rep->sline, p);
     httpHeaderPackInto(&rep->header, p);
     packerAppend(p, "\r\n", 2);
+}
+
+
+void
+httpReplyPackInto(const HttpReply * rep, Packer * p)
+{
+    httpReplyPackHeadersInto(rep, p);
     httpBodyPackInto(&rep->body, p);
 }
 
@@ -182,16 +191,15 @@
     return mb;
 }
 
-/* swap: create swap-based packer, pack, destroy packer */
+/* swap: create swap-based packer, pack, destroy packer
+ * This eats the reply.
+ */
 void
-httpReplySwapOut(const HttpReply * rep, StoreEntry * e)
+httpReplySwapOut(HttpReply * rep, StoreEntry * e)
 {
-    Packer p;
     assert(rep && e);
 
-    packerToStoreInit(&p, e);
-    httpReplyPackInto(rep, &p);
-    packerClean(&p);
+    storeEntryReplaceObject(e, rep);
 }
 
 MemBuf
@@ -206,26 +214,48 @@
     return mb;
 }
 
-MemBuf
-httpPacked304Reply(const HttpReply * rep)
+HttpReply *
+httpReplyMake304 (const HttpReply * rep)
 {
     static const http_hdr_type ImsEntries[] =
-    {HDR_DATE, HDR_CONTENT_TYPE, HDR_EXPIRES, HDR_LAST_MODIFIED, /* eof */ HDR_OTHER};
+      {HDR_DATE, HDR_CONTENT_TYPE, HDR_EXPIRES, HDR_LAST_MODIFIED, /* eof */ HDR_OTHER};
+    HttpReply *rv;
     int t;
-    MemBuf mb;
-    Packer p;
     HttpHeaderEntry *e;
     assert(rep);
-
-    memBufDefInit(&mb);
-    packerToMemInit(&p, &mb);
-    memBufPrintf(&mb, "%s", "HTTP/1.0 304 Not Modified\r\n");
+    
+    rv = httpReplyCreate ();
+    /* rv->content_length; */
+    rv->date = rep->date;
+    rv->last_modified = rep->last_modified;
+    rv->expires = rep->expires;
+    rv->content_type = stringDup (&rep->content_type);
+    /* rv->cache_control */
+    /* rv->content_range */
+    /* rv->keep_alive */
+    httpStatusLineSet(&rv->sline, httpStrategyOurVersion(httpStrategyGetStrategy()), 
+		      HTTP_NOT_MODIFIED, "");
+    
     for (t = 0; ImsEntries[t] != HDR_OTHER; ++t)
 	if ((e = httpHeaderFindEntry(&rep->header, ImsEntries[t])))
-	    httpHeaderEntryPackInto(e, &p);
-    memBufAppend(&mb, "\r\n", 2);
-    packerClean(&p);
-    return mb;
+	    httpHeaderAddEntry(&rv->header, httpHeaderEntryClone(e));
+    /* rv->body */
+    return rv;
+}
+
+MemBuf
+httpPacked304Reply(const HttpReply * rep)
+{
+    /* Not as efficient as skipping the header duplication,
+     * but easier to maintain 
+     */
+    HttpReply *temp;
+    MemBuf rv;
+    assert (rep);
+    temp = httpReplyMake304 (rep);
+    rv = httpReplyPack(temp);
+    httpReplyDestroy (temp);
+    return rv;
 }
 
 void
@@ -274,7 +304,7 @@
 }
 
 void
-httpReplyUpdateOnNotModified(HttpReply * rep, HttpReply * freshRep)
+httpReplyUpdateOnNotModified(HttpReply * rep, HttpReply const * freshRep)
 {
     assert(rep && freshRep);
     /* clean cache */
@@ -450,7 +480,7 @@
  * Returns the body size of a HTTP response
  */
 int
-httpReplyBodySize(method_t method, HttpReply * reply)
+httpReplyBodySize(method_t method, HttpReply const * reply)
 {
     if (METHOD_HEAD == method)
 	return 0;
--- /dev/null	Wed Feb 14 01:05:20 2007
+++ squid/src/HttpReply.h	Wed Feb 14 01:05:24 2007
@@ -0,0 +1,78 @@
+
+/*
+ * $Id: HttpReply.h,v 1.1.2.1 2002/09/05 10:28:18 rbcollins Exp $
+ *
+ *
+ * SQUID Web Proxy Cache          http://www.squid-cache.org/
+ * ----------------------------------------------------------
+ *
+ *  Squid is the result of efforts by numerous individuals from
+ *  the Internet community; see the CONTRIBUTORS file for full
+ *  details.   Many organizations have provided support for Squid's
+ *  development; see the SPONSORS file for full details.  Squid is
+ *  Copyrighted (C) 2001 by the Regents of the University of
+ *  California; see the COPYRIGHT file for full details.  Squid
+ *  incorporates software developed and/or copyrighted by other
+ *  sources; see the CREDITS file for full details.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *  
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *  
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
+ *
+ */
+
+#ifndef SQUID_HTTPREPLY_H
+#define SQUID_HTTPREPLY_H
+
+#include "typedefs.h"
+
+/* Http Reply */
+extern void httpReplyInitModule(void);
+/* create/destroy */
+extern HttpReply *httpReplyCreate(void);
+extern void httpReplyDestroy(HttpReply * rep);
+/* reset: clean, then init */
+extern void httpReplyReset(HttpReply * rep);
+/* absorb: copy the contents of a new reply to the old one, destroy new one */
+extern void httpReplyAbsorb(HttpReply * rep, HttpReply * new_rep);
+/* parse returns -1,0,+1 on error,need-more-data,success */
+extern int httpReplyParse(HttpReply * rep, const char *buf, ssize_t);
+extern void httpReplyPackHeadersInto(const HttpReply * rep, Packer * p);
+extern void httpReplyPackInto(const HttpReply * rep, Packer * p);
+/* ez-routines */
+/* mem-pack: returns a ready to use mem buffer with a packed reply */
+extern MemBuf httpReplyPack(const HttpReply * rep);
+/* swap: create swap-based packer, pack, destroy packer */
+extern void httpReplySwapOut(HttpReply * rep, StoreEntry * e);
+/* set commonly used info with one call */
+extern void httpReplySetHeaders(HttpReply * rep, http_version_t ver, http_status status,
+    const char *reason, const char *ctype, int clen, time_t lmt, time_t expires);
+/* do everything in one call: init, set, pack, clean, return MemBuf */
+extern MemBuf httpPackedReply(http_version_t ver, http_status status, const char *ctype,
+    int clen, time_t lmt, time_t expires);
+/* construct 304 reply and pack it into MemBuf, return MemBuf */
+extern MemBuf httpPacked304Reply(const HttpReply * rep);
+/* construct a 304 reply and return it */
+extern HttpReply *httpReplyMake304(const HttpReply *rep);
+/* update when 304 reply is received for a cached object */
+extern void httpReplyUpdateOnNotModified(HttpReply * rep, HttpReply const * freshRep);
+/* header manipulation */
+extern int httpReplyContentLen(const HttpReply * rep);
+extern const char *httpReplyContentType(const HttpReply * rep);
+extern time_t httpReplyExpires(const HttpReply * rep);
+extern int httpReplyHasCc(const HttpReply * rep, http_hdr_cc_type type);
+extern void httpRedirectReply(HttpReply *, http_status, const char *);
+extern int httpReplyBodySize(method_t, HttpReply const *);
+extern void httpReplyBodyBuildSize(request_t *, HttpReply *, dlink_list *);
+
+#endif /* SQUID_HTTPREPLY_H */
Index: squid/src/HttpRequest.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/HttpRequest.c,v
retrieving revision 1.7
retrieving revision 1.7.58.1
diff -u -r1.7 -r1.7.58.1
--- squid/src/HttpRequest.c	14 Apr 2001 00:31:01 -0000	1.7
+++ squid/src/HttpRequest.c	5 Sep 2002 10:28:18 -0000	1.7.58.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: HttpRequest.c,v 1.7 2001/04/14 00:31:01 squidadm Exp $
+ * $Id: HttpRequest.c,v 1.7.58.1 2002/09/05 10:28:18 rbcollins Exp $
  *
  * DEBUG: section 73    HTTP Request
  * AUTHOR: Duane Wessels
@@ -33,6 +33,7 @@
  *
  */
 
+#include "HttpRequest.h"
 #include "squid.h"
 
 request_t *
--- /dev/null	Wed Feb 14 01:05:20 2007
+++ squid/src/HttpRequest.h	Wed Feb 14 01:05:24 2007
@@ -0,0 +1,51 @@
+
+/*
+ * $Id: HttpRequest.h,v 1.1.2.1 2002/09/05 10:28:19 rbcollins Exp $
+ *
+ *
+ * SQUID Web Proxy Cache          http://www.squid-cache.org/
+ * ----------------------------------------------------------
+ *
+ *  Squid is the result of efforts by numerous individuals from
+ *  the Internet community; see the CONTRIBUTORS file for full
+ *  details.   Many organizations have provided support for Squid's
+ *  development; see the SPONSORS file for full details.  Squid is
+ *  Copyrighted (C) 2001 by the Regents of the University of
+ *  California; see the COPYRIGHT file for full details.  Squid
+ *  incorporates software developed and/or copyrighted by other
+ *  sources; see the CREDITS file for full details.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *  
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *  
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
+ *
+ */
+
+#ifndef SQUID_HTTPREQUEST_H
+#define SQUID_HTTPREQUEST_H
+
+#include "typedefs.h"
+
+/*  Http Request */
+extern request_t *requestCreate(method_t, protocol_t, const char *urlpath);
+extern void requestDestroy(request_t *);
+extern request_t *requestLink(request_t *);
+extern void requestUnlink(request_t *);
+extern int httpRequestParseHeader(request_t * req, const char *parse_start);
+extern void httpRequestSwapOut(const request_t * req, StoreEntry * e);
+extern void httpRequestPack(const request_t * req, Packer * p);
+extern int httpRequestPrefixLen(const request_t * req);
+extern int httpRequestHdrAllowed(const HttpHeaderEntry * e, String * strConnection);
+extern int httpRequestHdrAllowedByName(http_hdr_type id);
+
+#endif /* SQUID_HTTPREQUEST_H */
Index: squid/src/Makefile.am
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/Makefile.am,v
retrieving revision 1.23.6.2
retrieving revision 1.23.6.3
diff -u -r1.23.6.2 -r1.23.6.3
--- squid/src/Makefile.am	3 Sep 2002 08:31:20 -0000	1.23.6.2
+++ squid/src/Makefile.am	5 Sep 2002 10:28:19 -0000	1.23.6.3
@@ -114,6 +114,9 @@
 	cbdata.c \
 	client_db.c \
 	client_side.c \
+	client_side_reply.c \
+	client_side_request.c \
+	clientStream.c \
 	comm.c \
 	comm_select.c \
 	comm_poll.c \
Index: squid/src/acl.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/acl.c,v
retrieving revision 1.54.2.1
retrieving revision 1.54.2.2
diff -u -r1.54.2.1 -r1.54.2.2
--- squid/src/acl.c	3 Sep 2002 08:31:21 -0000	1.54.2.1
+++ squid/src/acl.c	5 Sep 2002 10:28:19 -0000	1.54.2.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: acl.c,v 1.54.2.1 2002/09/03 08:31:21 rbcollins Exp $
+ * $Id: acl.c,v 1.54.2.2 2002/09/05 10:28:19 rbcollins Exp $
  *
  * DEBUG: section 28    Access Control
  * AUTHOR: Duane Wessels
@@ -35,6 +35,7 @@
 
 #include "squid.h"
 #include "splay.h"
+#include "HttpRequest.h"
 
 static int aclFromFile = 0;
 static FILE *aclFile;
Index: squid/src/asn.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/asn.c,v
retrieving revision 1.17
retrieving revision 1.17.10.1
diff -u -r1.17 -r1.17.10.1
--- squid/src/asn.c	13 Apr 2002 23:09:15 -0000	1.17
+++ squid/src/asn.c	5 Sep 2002 10:28:20 -0000	1.17.10.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: asn.c,v 1.17 2002/04/13 23:09:15 squidadm Exp $
+ * $Id: asn.c,v 1.17.10.1 2002/09/05 10:28:20 rbcollins Exp $
  *
  * DEBUG: section 53    AS Number handling
  * AUTHOR: Duane Wessels, Kostas Anagnostakis
@@ -35,6 +35,7 @@
 
 #include "squid.h"
 #include "radix.h"
+#include "HttpRequest.h"
 
 #define WHOIS_PORT 43
 #define	AS_REQBUF_SZ	4096
Index: squid/src/cache_manager.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/cache_manager.c,v
retrieving revision 1.7
retrieving revision 1.7.80.1
diff -u -r1.7 -r1.7.80.1
--- squid/src/cache_manager.c	23 Feb 2001 21:03:30 -0000	1.7
+++ squid/src/cache_manager.c	5 Sep 2002 10:28:20 -0000	1.7.80.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: cache_manager.c,v 1.7 2001/02/23 21:03:30 hno Exp $
+ * $Id: cache_manager.c,v 1.7.80.1 2002/09/05 10:28:20 rbcollins Exp $
  *
  * DEBUG: section 16    Cache Manager Objects
  * AUTHOR: Duane Wessels
@@ -34,6 +34,8 @@
  */
 
 #include "squid.h"
+#include "HttpReply.h"
+#include "HttpRequest.h"
 
 #define MGR_PASSWD_SZ 128
 
@@ -235,10 +237,8 @@
 	 * password depends on action
 	 */
 	httpHeaderPutAuth(&rep->header, "Basic", mgr->action);
-	/* move info to the mem_obj->reply */
-	httpReplyAbsorb(entry->mem_obj->reply, rep);
 	/* store the reply */
-	httpReplySwapOut(entry->mem_obj->reply, entry);
+	httpReplySwapOut(rep, entry);
 	entry->expires = squid_curtime;
 	storeComplete(entry);
 	cachemgrStateFree(mgr);
@@ -254,9 +254,7 @@
 	storeBuffer(entry);
     {
 	http_version_t version;
-	HttpReply *rep = entry->mem_obj->reply;
-	/* prove there are no previous reply headers around */
-	assert(0 == rep->sline.status);
+	HttpReply *rep = httpReplyCreate();
 	httpBuildVersion(&version, 1, 0);
 	httpReplySetHeaders(rep,
 	    version,
